function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["children", "type", "icon", "color", "style", "others"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useMemo } from 'react';
import classNames from 'classnames';
import { generateColorShades } from "./utils";
import "./index.less";

// Pisell Tags 样式类型

// Pisell Tags 颜色

// Pisell Tags 属性

// 预设颜色枚举
var pisellTagsColors = {
  success: '#067647',
  warning: '#B54708',
  error: '#B42318',
  gray: '#344054'
};

/**
 * @title: 获取颜色
 * @description:
 * @param {PisellTagsColor} _color
 * @return {*}
 * @Author: zhiwei.Wang
 * @Date: 2024-08-23 16:07
 */
var getColor = function getColor(_color) {
  if (_color) {
    return pisellTagsColors[_color] || _color;
  }
  return '#344054';
};
var getPillColorStyles = function getPillColorStyles(_color) {
  var colorShades = generateColorShades(_color);
  return {
    '--pisell-tags-bg-color': colorShades['color_50'],
    '--pisell-tags-font-color': colorShades['color_700'],
    '--pisell-tags-border-color': colorShades['color_200']
  };
};
var getPillOutlineStyles = function getPillOutlineStyles(_color) {
  var colorShades = generateColorShades(_color);
  return {
    '--pisell-tags-bg-color': 'transparent',
    '--pisell-tags-font-color': colorShades['color_700'],
    '--pisell-tags-border-color': colorShades['color_600']
  };
};
var PisellTags = function PisellTags(props) {
  var children = props.children,
    type = props.type,
    icon = props.icon,
    color = props.color,
    _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    _props$others = props.others,
    others = _props$others === void 0 ? {} : _props$others,
    otherProps = _objectWithoutProperties(props, _excluded);
  var styles = useMemo(function () {
    var obj = _objectSpread(_objectSpread({}, style), others.style);
    var _color = getColor(props.color);
    if (type === 'pill_color') {
      obj = _objectSpread(_objectSpread({}, obj), getPillColorStyles(_color));
    }
    if (type === 'pill_outline') {
      obj = _objectSpread(_objectSpread({}, obj), getPillOutlineStyles(_color));
    }
    return obj;
  }, [color, style, others.style, type]);
  return /*#__PURE__*/React.createElement("span", _extends({
    style: _objectSpread(_objectSpread({}, styles), style)
  }, others, otherProps, {
    className: classNames('pisell-tags', others.className, otherProps.className)
  }), icon ? icon : null, children);
};
export default PisellTags;